/*----------------------------------------------------------------------------
 * Nazwa:   Stale_Zmienne_Scenariusze.c	  
 * Funkcja: Plik deklaracji staych i zmiennych
 * @author  ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    9-03-2013
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
 *----------------------------------------------------------------------------
 * Plik zawiera:
 *
 *
 * Copyright (c) ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
#include "stm32f2xx_conf.h"
#include "Definicje_sprzet.h"
#include "Definicje_program.h"
#include "EEPROM_procedury.h"
#include "Kamera.h"


	#if (ZAMONTOWANA_KAMERA ==ZAMONTOWANA_KAMERA_MT9D111)
#define	TYP_KAMERY				"-K1"
	#else
#define	TYP_KAMERY				""
	#endif

	#if	(ZEGAR_RTC ==ZAMONTOWANY_ZEGAR_RTC)
#define	TYP_ZEGARA_RTC			"-Z"
	#else						
#define	TYP_ZEGARA_RTC			""
#endif

const char wersja_oprogramowania_tab[] ={"ARS3" TYP_KAMERY TYP_ZEGARA_RTC " v.2.15-4-6-2"};	

//UWAGA musi by zachowana zgodno z sygnatury formatu min/max obrazu Kamera.h
	#if (ZAMONTOWANA_KAMERA	==ZAMONTOWANA_KAMERA_MT9D111)
const char info_parametry_kamery_tab[] ={"(1)160x120c_BMP (2)160x120c_JPG (3)320x240c_JPG (4)640x480c_JPG t:MT9D111 a:-,-"};

const int obraz_ozo_parametry_tab[5][4] ={{0, 0, 0, 0},
									  {QQVGA_ILOSC_PIKSELI, QQVGA_ILOSC_LINII, QQVGA_ILOSC_BAJTOW_NA_PIKSEL, OBRAZ_PLIK_BMP},
									  {QQVGA_ILOSC_PIKSELI, QQVGA_ILOSC_LINII, QQVGA_ILOSC_BAJTOW_NA_PIKSEL, OBRAZ_PLIK_JPG},
									  {QVGA_ILOSC_PIKSELI, QVGA_ILOSC_LINII, QVGA_ILOSC_BAJTOW_NA_PIKSEL, OBRAZ_PLIK_JPG},
									  {VGA_ILOSC_PIKSELI, VGA_ILOSC_LINII, VGA_ILOSC_BAJTOW_NA_PIKSEL, OBRAZ_PLIK_JPG}};

	#else
const char info_parametry_kamery_tab[] ={"t:brak a:-,-"};

const int obraz_ozo_parametry_tab[][3] ={{0, 0, 0}};
#endif

//-------------------------------------------------
//lista flag opcji ustawie kamery w kolejnoci identyfikatorw -1
const char ats404p_lista_flag_string[] ={"lustro_poziom<1>[=0/1] lustro_pion<2>[=0/1] "
										 "dua_kompresja<3>[=0/1] AE_standard<4>[=0/1]"};

//struktura zmiennych kontrolujcych spjo wymiany danych
struct CNL_SPOJ_WYMIANY_DANYCH{
	char identyfikator_transmisji_wysylanej;
	char identyfikator_ostatniej_trans_odebranej;
	char ile_powtorzen_transmisji;
	uint16_t czas_oczekiwania_na_odpowiedz_ms;
	char *p_bufor_bak;
	int  rozmiar_transmisji_bak;
	char *p_koniec_danych_bak;
	char stan_urzadzenia_bak;
	}cnl_spoj_wymiany_danych; 
//struktura kontrolujca parametry retransmisji i prefiksu ustawiane rozkazem F
struct PREFIKS{
	char flaga_retransmisji;
	char alias_odbiorcy[ROZMIAR_ALIASU_MAX+1];
	char kanal;
	}prefiks;
//struktura zawierajca parametry ostatnio zarejestrowanego obrazka ozo.jpg
struct OZO_STRUCT{
	char *p_ozo_buf_plik_obraz;//wskanik do buforu z plikiem formatowanym obrazka jpg/bmp
	char ozo_format;			//format ozo
	char ozo_format_bak;		//poprzedni format ozo
	int ozo_obraz_szer_pix;		//szeroko obrazka w pikselach
	int ozo_obraz_wys_lin;		//wysoko obrazka w liniach
	char ozo_obraz_bajty_na_pix;//ilo bajtw na pikselc w tym formacie obrazka
	int rozmiar_pliku_ozo;		//rozmiar pliku obrazka
	char ozo_plik_obraz_typ;	//typ pliku obrazka ozo
	}ozo_struct;
//struktura zawierajca parametry wykorzystywane podczas transmisji plikw
struct OBSLUGA_PRZESLANIA_PLIKU{
		char *p_poz_kolejnych_danych_biezaca;
	    char *p_poz_kolejnych_danych_poprzednia;
		int rozmiar_pojedynczego_przeslania_bajty;
		int ile_przeslan_pelnych;
		int rozmiar_ostatniego_przeslania_bajty;
		int rozmiar_buforu_RAM;
		int rozmiar_pliku;
		int ile_danych_przeslano;
		int data_utworzenia_pliku;
		int czas_utworzenia_pliku;
		char sciezka_dostepu_do_pliku_tab[ROZMIAR_SCIEZKI_DOSTEPU_MAX+1];
	  }obsluga_przeslania_pliku;

