/**
  ******************************************************************************
  * plik    main.c
  * funkcja gwna procedura MAIN
  * autor   ARIES Ryszard Szymaniak www.arskam.com
  * wersja  2.15-4-6-2
  * data    9-03-2013
  * opis    gwna procedura systemu ARS3 dla pytki ARS3-KZ v.4
  *         sterownik ARS3-MT9D111 obsugujcy modu kamery MT9D111 firmy APTINA
  * ukad:  STM32F217VGT  konfiguracja STM322xG_EVAL
  * przed kompilacj naley w pliku Definicje_sprzet.h zdefiniowa ustawienia sprztowe
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "stm32f2xx_conf.h"
#include "GPIO_procedury.h"
#include "Procedury Ogolne.h"
#include "Definicje_program.h"
//#include "EEPROM_procedury.h"
#include "USART_procedury.h"
#include "TIMER_procedury.h"
#include "Tryb_AT.h"
#include "Tryb_Formatowany.h"
#include "Kamera.h"
#include "Kamera_DMA.h"
//#include <stdio.h>

#include "MT9D111.h"

//zmienne USART1
extern char PRZERWA_TRANSMISJI_USART_GP_FLAG;//extern char przerwa_transmisji_USART1_flag;
extern char *p_BUFOR_RX_USART_GP;//extern char *p_bufor_rx_USART1;//wskanik do pocztku buforu odbiorczego UARTA1
extern int BUFOR_RX_USART_GP_ROZMIAR;//extern int bufor_rx_USART1_rozmiar;//bajt okrelajcy cakowity rozmiar buforu odbiorczego UARTA1
extern char *p_RX_USART_GP_IN;//extern char *p_rx_USART1_in;//wskanik biecej pozycji w buf.odbiorczym dla danych zapisywanych w buf.
extern char *p_RX_USART_GP_OUT;//extern char *p_rx_USART1_out;//wskanik biecej pozycji w buf.odbiorczym dla danych odczytywanych z buf.

extern uint8_t	proc_ogol_stan_urzadzenia_info;

//zmienne KAMERA
extern struct OZO_STRUCT{
	char *p_ozo_buf_plik_obraz;//wskanik do buforu z plikiem jpg obrazka
	char ozo_format;			//format ozo
	char ozo_format_bak;		//poprzedni format ozo
	int ozo_obraz_szer_pix;		//szeroko obrazka w pikselach
	int ozo_obraz_wys_lin;		//wysoko obrazka w liniach
	char ozo_obraz_bajty_na_pix;//ilo bajtw na pikselc w tym formacie obrazka
	int rozmiar_pliku_ozo;		//rozmiar pliku obrazka
	char ozo_plik_obraz_typ;	//typ pliku obrazka ozo
	}ozo_struct;

extern int obraz_ozo_parametry_tab[][4];

int main(void)
{
char *p_tmp=NULL, status;
char jaskrawosc[2], kontrast[2], nasycenie[2];


  /*!< At this stage the microcontroller clock setting is already configured, 
       this is done through SystemInit() function which is called from startup
       file (startup_stm32f10x_xx.s) before to branch to application main.
       To reconfigure the default setting of SystemInit() function, refer to
       system_stm32f10x.c file
     */     

	GPIO_Inicjacja();
	USART_Inicjacja();
	TIMERY_Inicjacja();
	NVIC_Configuration();

	//ustawienie wartoci pocztkowych zmiennych
	proc_ogol_stan_urzadzenia_info =STAN_URZADZENIA_RX_TX;//identyfikator biecego stanu urzdzenia
	PRZERWA_TRANSMISJI_USART_GP_FLAG =FALSE;

 	 //format obrazu kamery
  	ozo_struct.ozo_format =NUMER_FORMATU_OZO_QQVGA_BMP;
	ozo_struct.ozo_obraz_szer_pix =obraz_ozo_parametry_tab[ozo_struct.ozo_format][OBRAZ_PARAM_PIKSELE_POZ];
    ozo_struct.ozo_obraz_wys_lin =obraz_ozo_parametry_tab[ozo_struct.ozo_format][OBRAZ_PARAM_LINIE_POZ];
    ozo_struct.ozo_obraz_bajty_na_pix =obraz_ozo_parametry_tab[ozo_struct.ozo_format][OBRAZ_PARAM_BAJTY_NA_PIKS];
	ozo_struct.ozo_format_bak =NUMER_FORMATU_OBRAZU_ZADEN;

	Kamera_Inicjacja(ozo_struct.ozo_obraz_szer_pix, ozo_struct.ozo_obraz_wys_lin, ozo_struct.ozo_obraz_bajty_na_pix);
	status =Kamera_Zmiana_Formatu_Obrazu(ozo_struct.ozo_format);

	if (status ==FALSE)
	{
		GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
		Delay_ms(300);
		GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
		GPIO_Linie_IO_Low(LINIA_LED_CZERWONY_WY);
	    Delay_ms(300);
		GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
		GPIO_Linie_IO_Low(LINIA_LED_ZIELONY_WY);
		Delay_ms(300);
		GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
		GPIO_Linie_IO_Low(LINIA_LED_CZERWONY_WY);
		Delay_ms(300);
		GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
		GPIO_Linie_IO_Low(LINIA_LED_ZIELONY_WY);
	    Delay_ms(300);
	}
    else
	{

	GPIO_Linie_IO_Low(LINIA_LED_ZIELONY_WY);
	GPIO_Linie_IO_Low(LINIA_LED_CZERWONY_WY);
    Delay_ms(300);
	GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
	GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
	Delay_ms(300);
	GPIO_Linie_IO_Low(LINIA_LED_ZIELONY_WY);
	GPIO_Linie_IO_Low(LINIA_LED_CZERWONY_WY);
    Delay_ms(300);
	GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
	GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);

	readMCUMemory(AE_TARGET_JASKRAWOSC, &jaskrawosc[0]);
	readMCUMemory(GAM_CONT_B_KONTRAST, &kontrast[0]);
	readMCUMemory(AWB_SATURATION_NASYCENIE, &nasycenie[0]);
    }

  while (1)
  {
  	//obsuga odbioru USART1
	//-----------------------
  	if (PRZERWA_TRANSMISJI_USART_GP_FLAG ==TRUE)
	{
	    PRZERWA_TRANSMISJI_USART_GP_FLAG =FALSE;
		p_tmp =p_RX_USART_GP_IN;
		status =Kontrola_komendy_tryb_AT_on(p_BUFOR_RX_USART_GP, BUFOR_RX_USART_GP_ROZMIAR, p_RX_USART_GP_OUT, p_tmp);
		if (status ==TRUE)
		{
			//zosta odebrany prawidowy rozkaz +++ inicjacji Trybu AT
			//zerowanie wskanikw buforu UART-a, w Trybie AT bufor bdzie obsugiwany jako liniowy a nie koowy
			p_RX_USART_GP_IN =p_BUFOR_RX_USART_GP;
			p_RX_USART_GP_OUT =p_RX_USART_GP_IN;
			GPIO_Linie_IO_Low(LINIA_LED_ZIELONY_WY);
			proc_ogol_stan_urzadzenia_info =STAN_URZADZENIA_TRYB_AT_UART;
			TIMER4_Detekcja_przerwy_trans_start(CZAS_AUTOMAT_ZAMKNIECIA_TRYBU_AT_MS);

			Tryb_AT_potwierdzenie_OK();
			continue;
		}
		//Tryb AT urzdzenia
		if (proc_ogol_stan_urzadzenia_info ==STAN_URZADZENIA_TRYB_AT_UART)
		{
			if (Oblicz_Ilosc_Danych_w_Buf_Kolowym(p_BUFOR_RX_USART_GP, BUFOR_RX_USART_GP_ROZMIAR, p_RX_USART_GP_OUT, p_tmp) ==0)
			{
				//aktywna flaga upywu przerwy transmisji przy braku danych w buforze oznacza
				//konieczno automatycznego zakoczenia Trybu AT
				proc_ogol_stan_urzadzenia_info =STAN_URZADZENIA_RX_TX;
				GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
				GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
				p_RX_USART_GP_IN =p_BUFOR_RX_USART_GP;
				p_RX_USART_GP_OUT =p_RX_USART_GP_IN;
				continue;
			}
			Obsluga_Trybu_AT(p_BUFOR_RX_USART_GP, BUFOR_RX_USART_GP_ROZMIAR, p_RX_USART_GP_OUT, p_tmp);
			p_RX_USART_GP_IN =p_BUFOR_RX_USART_GP;
			p_RX_USART_GP_OUT =p_RX_USART_GP_IN;
			continue;
		}
		//Tryb Sterownika
		if (proc_ogol_stan_urzadzenia_info ==STAN_URZADZENIA_RX_TX)
		{
			Obsluga_Trybu_Formatowanego(p_BUFOR_RX_USART_GP, BUFOR_RX_USART_GP_ROZMIAR, p_RX_USART_GP_OUT, p_tmp);
		}

		p_RX_USART_GP_IN =p_BUFOR_RX_USART_GP;
		p_RX_USART_GP_OUT =p_RX_USART_GP_IN;
	}
  }
}

/**
  * @brief  Retargets the C library printf function to the USART.
  * @param  None
  * @retval None
  */  
//PUTCHAR_PROTOTYPE
//{
  /* Place your implementation of fputc here */
  /* e.g. write a character to the USART */
//  USART_SendData(EVAL_COM1, (uint8_t) ch);

  /* Loop until the end of transmission */
//  while (USART_GetFlagStatus(EVAL_COM1, USART_FLAG_TC) == RESET)
//  {}

//  return ch;
//}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
