/**
  ******************************************************************************
  * @file    Project/STM32F2xx_StdPeriph_Template/stm32f2xx_it.c 
  * @author  MCD Application Team
  * @version V1.1.0
  * @date    13-April-2012
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2012 STMicroelectronics</center></h2>
  *
  * Licensed under MCD-ST Liberty SW License Agreement V2, (the "License");
  * You may not use this file except in compliance with the License.
  * You may obtain a copy of the License at:
  *
  *        http://www.st.com/software_license_agreement_liberty_v2
  *
  * Unless required by applicable law or agreed to in writing, software 
  * distributed under the License is distributed on an "AS IS" BASIS, 
  * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  * See the License for the specific language governing permissions and
  * limitations under the License.
  *
  ******************************************************************************
  */ 

/* Includes ------------------------------------------------------------------*/
#include "stm32f2xx_it.h"
#include "Definicje_sprzet.h"
#include "TIMER_procedury.h"

/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
//zmienne USART1
extern char *p_bufor_rx_USART1;//wskanik do pocztku buforu odbiorczego UARTA
extern int bufor_rx_USART1_rozmiar;//bajt okrelajcy cakowity rozmiar buforu odbiorczego UARTA
extern char *p_rx_USART1_in;//wskanik biecej pozycji w buf.odbiorczym dla danych zapisywanych w buf.
extern char *p_rx_USART1_out;//wskanik biecej pozycji w buf.odbiorczym dla danych odczytywanych z buf.

extern char *p_bufor_tx_USART1;//wskanik do pocztku buforu transmisji UARTA
extern int bufor_tx_USART1_rozmiar;//bajt okrelajcy cakowity rozmiar buforu transmisji UARTA
extern char *p_tx_USART1_in;//wskanik biecej pozycji w buf.nadawczym dla danych zapisywanych w buf.
extern char *p_tx_USART1_out;//wskanik biecej pozycji w buf.nadawczym dla danych odczytywanych z buf.
extern char tx_USART1_restart_flag;//poprzednia transmisja zakoczona, nowa musi by zainicjowana

extern uint16_t czas_przerwy_transmisji_UART1;
extern char przerwa_transmisji_USART1_flag;
//TIMER4 stopery
extern char flaga_stopera1;

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief   This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{
}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Memory Manage exception.
  * @param  None
  * @retval None
  */
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Bus Fault exception.
  * @param  None
  * @retval None
  */
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles Usage Fault exception.
  * @param  None
  * @retval None
  */
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles Debug Monitor exception.
  * @param  None
  * @retval None
  */
void DebugMon_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
  * @brief  This function handles SysTick Handler.
  * @param  None
  * @retval None
  */
void SysTick_Handler(void)
{
 
}

/******************************************************************************/
/*                 STM32F2xx Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f2xx.s).                                               */
/******************************************************************************/

/**
  * @brief  This function handles PPP interrupt request.
  * @param  None
  * @retval None
  */
/*void PPP_IRQHandler(void)
{
}*/

/**
  * @}
  */ 
  /**
  * port szeregowy USART1
  * wykorzystywany do komunikacji z PC
  */
//----------------------------------------------------
void USART_1_IRQHandler(void)	
{ 
	//obsuga przerwania USART1
  if(USART_GetITStatus(USART_1, USART_IT_RXNE) != RESET)
  {
    /* Read one byte from the receive data register USART1*/
	*p_rx_USART1_in =USART_ReceiveData(USART_1);
	
	p_rx_USART1_in++;
	if (p_rx_USART1_in >=(p_bufor_rx_USART1 +bufor_rx_USART1_rozmiar))//koowy bufor Rx UART-a
	{
		p_rx_USART1_in =p_bufor_rx_USART1;
	}
	//detekcja przerwy w odbiorze
	TIMER4_Detekcja_przerwy_trans_start(czas_przerwy_transmisji_UART1);
	
  }
  if(USART_GetITStatus(USART_1, USART_IT_TXE) != RESET)
  {   
    /* Write one byte to the transmit data register USART1*/
	if (p_tx_USART1_in !=p_tx_USART1_out)
	{			   
		//w buforze transmisji s znaki do wysania uart-em
		USART_SendData(USART_1, *p_tx_USART1_out);			 
		p_tx_USART1_out++;
		if (p_tx_USART1_out >=(p_bufor_tx_USART1 +bufor_tx_USART1_rozmiar)) //koowy bufor tx uart-a
		{				
			p_tx_USART1_out =p_bufor_tx_USART1;
		}
	}
	else
	{
		USART_ITConfig(USART_1, USART_IT_TXE, DISABLE);// disable tx interrupt if nothing to send
		tx_USART1_restart_flag = 1;
	}
  }
}

/**
  * @}
  */ 
  /**
  * port szeregowy USART2
  * 
  */
//----------------------------------------------------
void USART_2_IRQHandler(void)	
{ 
	//obsuga przerwania USART2
  if(USART_GetITStatus(USART_2, USART_IT_RXNE) != RESET)
  {
  }	   
}
//--------------------------------------------------
//TIM2 
void TIM2_IRQHandler(void)
{
  if (TIM_GetITStatus(TIM2, TIM_IT_CC3) != RESET)
  {
  }
}

//--------------------------------------------------
//TIM4 licznik czasu przerwy transmisji UART1
void TIM4_IRQHandler(void)
{
  if (TIM_GetITStatus(TIM4, TIM_IT_CC1) != RESET)
  {
    //kana CC1 steruje odliczaniem czasu Stopera1
    TIM_ClearITPendingBit(TIM4, TIM_IT_CC1);
	//wyczenie przerwania kanau
	TIM_ITConfig(TIM4, TIM_IT_CC1, DISABLE);
	flaga_stopera1 =TRUE;
  }	
  if (TIM_GetITStatus(TIM4, TIM_IT_CC2) != RESET)
  {
    //kana CC2 steruje pomiarem czasu przerwy odbioru transmisji USART
    TIM_ClearITPendingBit(TIM4, TIM_IT_CC2);

	przerwa_transmisji_USART1_flag =TRUE;
	//wyczenie przerwania kanau
	TIM_ITConfig(TIM4, TIM_IT_CC2, DISABLE);
  }
}

//--------------------------------------------------
//TIM5 licznik czasu przerwy transmisji UART
void TIM5_IRQHandler(void)
{
  if (TIM_GetITStatus(TIM5, TIM_IT_CC2) != RESET)
  {
  }
}

//-------------------------------------------------
//przerwania DCMI
void DCMI_IRQHandler(void)
{
extern uint8_t	  dcmi_flag_frameri_bak, dcmi_flag_lineri_bak, dcmi_flag_errri_bak, dcmi_flag_ovfri_bak, dcmi_flag_vsyncri_bak;

	if (DCMI_GetFlagStatus(DCMI_FLAG_VSYNCRI) ==SET)
	{
		dcmi_flag_vsyncri_bak =TRUE;
	}
	if (DCMI_GetFlagStatus(DCMI_FLAG_LINERI) ==SET)
	{
	}
	if (DCMI_GetFlagStatus(DCMI_FLAG_LINEMI) ==SET)
	{
		dcmi_flag_lineri_bak =TRUE;
	}
	if (DCMI_GetFlagStatus(DCMI_FLAG_FRAMERI) ==SET)
	{
		dcmi_flag_frameri_bak =TRUE;
	}
	if (DCMI_GetFlagStatus(DCMI_FLAG_ERRRI) ==SET)
	{
		dcmi_flag_errri_bak =TRUE;
	}
	if (DCMI_GetFlagStatus(DCMI_FLAG_OVFRI) ==SET)
	{
		dcmi_flag_ovfri_bak =TRUE;
	}

	DCMI_ClearFlag(DCMI_FLAG_VSYNCRI);
    DCMI_ClearFlag(DCMI_FLAG_LINERI);
	DCMI_ClearFlag(DCMI_FLAG_LINEMI);
	DCMI_ClearFlag(DCMI_FLAG_FRAMERI);
	DCMI_ClearFlag(DCMI_FLAG_ERRRI);
	DCMI_ClearFlag(DCMI_FLAG_OVFRI);
}
//------------------------------------------------------
//przerwanie DMA
void DMA2_Stream1_IRQHandler(void)
{
    static uint8_t ucCount = 0;
    DMA_ClearITPendingBit ( DMA2_Stream1, DMA_IT_TCIF1 );
    ucCount++;
}
/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
