/**
  ******************************************************************************
  * plik    USART_procedury.c	
  * funkcja	Plik procedur zwizanych z portami szeregowymi USART 
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    8-08-2012
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
#include "USART_procedury.h"
#include "stm32f2xx_conf.h"
#include "Definicje_sprzet.h"
#include "Definicje_program.h"
#include "EEPROM_procedury.h"

USART_InitTypeDef USART_InitStructure;

uint32_t uart_speed;

//zmienne procedur USART1
char bufor_rx_USART1[ROZMIAR_BUF_RX_TX];//bufor odbiorczy UARTA1
char bufor_tx_USART1[ROZMIAR_BUF_RX_TX];//bufor transmisji UARTA1

char *p_bufor_rx_USART1;//wskanik do pocztku buforu odbiorczego UARTA1
int bufor_rx_USART1_rozmiar;//bajt okrelajcy cakowity rozmiar buforu odbiorczego UARTA1
char *p_rx_USART1_in;//wskanik biecej pozycji w buf.odbiorczym dla danych zapisywanych w buf.
char *p_rx_USART1_out;//wskanik biecej pozycji w buf.odbiorczym dla danych odczytywanych z buf.

char *p_bufor_tx_USART1;//wskanik do pocztku buforu transmisji UARTA1
int bufor_tx_USART1_rozmiar;//bajt okrelajcy cakowity rozmiar buforu transmisji UARTA1
char *p_tx_USART1_in;//wskanik biecej pozycji w buf.nadawczym dla danych zapisywanych w buf.
char *p_tx_USART1_out;//wskanik biecej pozycji w buf.nadawczym dla danych odczytywanych z buf.
char tx_USART1_restart_flag;//poprzednia transmisja zakoczona, nowa musi by zainicjowana

char przerwa_transmisji_USART1_flag;
uint16_t czas_przerwy_transmisji_UART1;

//zmienne procedur USART2
char bufor_rx_USART2[ROZMIAR_BUF_RX_TX];//bufor odbiorczy UARTA3
char bufor_tx_USART2[ROZMIAR_BUF_RX_TX];//bufor transmisji UARTA3

char *p_bufor_rx_USART2;//wskanik do pocztku buforu odbiorczego UARTA2
int bufor_rx_USART2_rozmiar;//bajt okrelajcy cakowity rozmiar buforu odbiorczego UARTA2
char *p_rx_USART2_in;//wskanik biecej pozycji w buf.odbiorczym dla danych zapisywanych w buf.
char *p_rx_USART2_out;//wskanik biecej pozycji w buf.odbiorczym dla danych odczytywanych z buf.

char *p_bufor_tx_USART2;//wskanik do pocztku buforu transmisji UARTA2
int bufor_tx_USART2_rozmiar;//bajt okrelajcy cakowity rozmiar buforu transmisji UARTA2
char *p_tx_USART2_in;//wskanik biecej pozycji w buf.nadawczym dla danych zapisywanych w buf.
char *p_tx_USART2_out;//wskanik biecej pozycji w buf.nadawczym dla danych odczytywanych z buf.
char tx_USART2_restart_flag;//poprzednia transmisja zakoczona, nowa musi by zainicjowana

char przerwa_transmisji_USART2_flag;


//zmienne procedur USART3
char bufor_rx_USART3[ROZMIAR_BUF_RX_TX];//bufor odbiorczy UARTA3
char bufor_tx_USART3[ROZMIAR_BUF_RX_TX];//bufor transmisji UARTA3

char *p_bufor_rx_USART3;//wskanik do pocztku buforu odbiorczego UARTA3
int bufor_rx_USART3_rozmiar;//bajt okrelajcy cakowity rozmiar buforu odbiorczego UARTA3
char *p_rx_USART3_in;//wskanik biecej pozycji w buf.odbiorczym dla danych zapisywanych w buf.
char *p_rx_USART3_out;//wskanik biecej pozycji w buf.odbiorczym dla danych odczytywanych z buf.

char *p_bufor_tx_USART3;//wskanik do pocztku buforu transmisji UARTA3
int bufor_tx_USART3_rozmiar;//bajt okrelajcy cakowity rozmiar buforu transmisji UARTA3
char *p_tx_USART3_in;//wskanik biecej pozycji w buf.nadawczym dla danych zapisywanych w buf.
char *p_tx_USART3_out;//wskanik biecej pozycji w buf.nadawczym dla danych odczytywanych z buf.
char tx_USART3_restart_flag;//poprzednia transmisja zakoczona, nowa musi by zainicjowana

char przerwa_transmisji_USART3_flag;


//tablica ze staymi dostpnych szybkoci UARTA
const int dostepne_szybkosci_uarta_tab[] ={U_1200_BAUD, U_2400_BAUD, U_4800_BAUD,
                                           		U_9600_BAUD, U_19200_BAUD, U_38400_BAUD,
										   		U_57600_BAUD, U_115200_BAUD};
//deklaracje przerwy w transmisji =1 ramce, pomiar w 0.1ms
const int czasy_ramki_trans_uarta_tab[]  ={U_1200_PRZERWA_01MS, U_2400_PRZERWA_01MS, U_4800_PRZERWA_01MS,
										   U_9600_PRZERWA_01MS, U_19200_PRZERWA_01MS, U_38400_PRZERWA_01MS,
										   U_57600_PRZERWA_01MS, U_115200_PRZERWA_01MS};

//Procedury Oglne
//struktura zmiennych kontrolujcych spjo wymiany danych
extern struct CNL_SPOJ_WYMIANY_DANYCH{
	char identyfikator_transmisji_wysylanej;
	char identyfikator_ostatniej_trans_odebranej;
	char ile_powtorzen_transmisji;
	uint16_t czas_oczekiwania_na_odpowiedz_ms;
	char *p_bufor_bak;
	int  rozmiar_transmisji_bak;
	char *p_koniec_danych_bak;
	char stan_urzadzenia_bak;
	}cnl_spoj_wymiany_danych; 

extern uint8_t	proc_ogol_stan_urzadzenia_info;

//gwna procedura inicjacji czy USART
void USART_Inicjacja(void)
{
char status, tmp;

  	status =EepOdczyt(EEP_ADR_NUMER_SZYBKOSCI_UART, 1, &tmp);

  	if ((tmp >(ILOSC_SZYBKOSCI_TRANSMISJI_UART-1)) || (status !=TRUE))
  	{
		//bd proba wyboru niedostpnego numeru szybkoci transmisji
		//lub odczytu z EEPROM
		uart_speed =38400;
		CZAS_PRZERWY_TRANSMISJI_UART_GP =((U_38400_PRZERWA_01MS *2) /10)+4;
  	}
 	else
  	{
	 	uart_speed =dostepne_szybkosci_uarta_tab[tmp];//w EEP numer szybkoci liczony od 0 
		CZAS_PRZERWY_TRANSMISJI_UART_GP =((czasy_ramki_trans_uarta_tab[tmp]*2)/10)+4;
  	}

	USART1_GPIO_Configuration();
	USART1_Inicjacja(uart_speed);

    //inicjacja zmiennych Rx  USART1 buforu koowego odbioru
	USART_ClearFlag (USART_1, USART_FLAG_TC | USART_FLAG_RXNE);
	USART_ClearITPendingBit  (USART_1, USART_IT_TC | USART_IT_RXNE);
	p_bufor_rx_USART1 = &bufor_rx_USART1[0];
	bufor_rx_USART1_rozmiar =sizeof(bufor_rx_USART1);
	p_rx_USART1_in =p_bufor_rx_USART1;
	p_rx_USART1_out =p_bufor_rx_USART1;

	p_bufor_tx_USART1 =&bufor_tx_USART1[0];
	tx_USART1_restart_flag =TRUE;				//flaga koniecznoci inicjacji przerwania transmisji USART1
	przerwa_transmisji_USART1_flag =FALSE;				//flaga przerwy w odebranej transmisji USART1

}

/**
  * @brief  Configures the different GPIO ports.
  * @param  None
  * @retval None
  inicjacja i konfiguracja linii I/O bdcych wyprowadzeniami Rx, Tx
  portw USART1
  */
void USART1_GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Peripheral Clock Enable -------------------------------------------------*/
  /* Enable GPIO clock */
  RCC_AHB1PeriphClockCmd(USART_1_TX_GPIO_CLK | USART_1_RX_GPIO_CLK, ENABLE);
  
  /* Enable USART clock */
  RCC_APB2PeriphClockCmd(USART_1_CLK, ENABLE);

  
  /* USARTx GPIO configuration -----------------------------------------------*/ 
  /* Connect USART pins to AF7 */
  GPIO_PinAFConfig(USART_1_TX_GPIO_PORT, USART_1_TX_SOURCE, USART_1_TX_AF);
  GPIO_PinAFConfig(USART_1_RX_GPIO_PORT, USART_1_RX_SOURCE, USART_1_RX_AF);
  
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  
  GPIO_InitStructure.GPIO_Pin = USART_1_TX_PIN;
  GPIO_Init(USART_1_TX_GPIO_PORT, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin = USART_1_RX_PIN;
  GPIO_Init(USART_1_RX_GPIO_PORT, &GPIO_InitStructure);
 
}
/**
  * @brief  Configures the different GPIO ports.
  * @param  None
  * @retval None
  inicjacja i konfiguracja linii I/O bdcych wyprowadzeniami Rx, Tx
  portw USART2
  */
void USART2_GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Peripheral Clock Enable -------------------------------------------------*/
  /* Enable GPIO clock */
  RCC_AHB1PeriphClockCmd(USART_2_TX_GPIO_CLK | USART_2_RX_GPIO_CLK, ENABLE);
  
  /* Enable USART clock */
  USARTx_CLK_INIT(USART_2_CLK, ENABLE);
  
  /* USARTx GPIO configuration -----------------------------------------------*/ 
  /* Connect USART pins to AF7 */
  GPIO_PinAFConfig(USART_2_TX_GPIO_PORT, USART_2_TX_SOURCE, USART_2_TX_AF);
  GPIO_PinAFConfig(USART_2_RX_GPIO_PORT, USART_2_RX_SOURCE, USART_2_RX_AF);
  
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  
  GPIO_InitStructure.GPIO_Pin = USART_2_TX_PIN;
  GPIO_Init(USART_2_TX_GPIO_PORT, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;

  GPIO_InitStructure.GPIO_Pin = USART_2_RX_PIN;
  GPIO_Init(USART_2_RX_GPIO_PORT, &GPIO_InitStructure);	 

}
/**
  * @brief  Configures the different GPIO ports.
  * @param  None
  * @retval None
  inicjacja i konfiguracja linii I/O bdcych wyprowadzeniami Rx, Tx
  portw USART3
  */
void USART3_GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;

  /* Peripheral Clock Enable -------------------------------------------------*/
  /* Enable GPIO clock */
  RCC_AHB1PeriphClockCmd(USART_3_TX_GPIO_CLK | USART_3_RX_GPIO_CLK, ENABLE);
  
  /* Enable USART clock */
  USARTx_CLK_INIT(USART_3_CLK, ENABLE);
  
  /* USARTx GPIO configuration -----------------------------------------------*/ 
  /* Connect USART pins to AF7 */
  GPIO_PinAFConfig(USART_3_TX_GPIO_PORT, USART_3_TX_SOURCE, USART_3_TX_AF);
  GPIO_PinAFConfig(USART_3_RX_GPIO_PORT, USART_3_RX_SOURCE, USART_3_RX_AF);
  
  /* Configure USART Tx and Rx as alternate function push-pull */
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  
  GPIO_InitStructure.GPIO_Pin = USART_3_TX_PIN;
  GPIO_Init(USART_3_TX_GPIO_PORT, &GPIO_InitStructure);
  
  GPIO_InitStructure.GPIO_Pin = USART_3_RX_PIN;
  GPIO_Init(USART_3_RX_GPIO_PORT, &GPIO_InitStructure);
}


//---------------------------------
 //procedury inicjacji portu USART1
 void USART1_Inicjacja(uint32_t usart_speed)
 {
   /* USARTy and USARTz configured as follow:
        - BaudRate = 19200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled
  */ 
  /* Enable the USART OverSampling by 8 */
  USART_OverSampling8Cmd(USART1, ENABLE); 

  USART_Cmd(USART_1, DISABLE);
  USART_InitStructure.USART_BaudRate =usart_speed;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Configure USART1 */ 
  USART_Init(USART_1, &USART_InitStructure);
  
  /* Enable USARTy Receive and Transmit interrupts USART1*/	
  USART_ITConfig(USART_1, USART_IT_RXNE, ENABLE);

  /* Enable the USART1 */
  USART_Cmd(USART_1, ENABLE);

 }
 //---------------------------------
 //procedury inicjacji portu USART2)
 void USART2_Inicjacja(uint32_t usart_speed)
 {
  /* Enable the USART OverSampling by 8 */
  USART_OverSampling8Cmd(USART2, ENABLE); 

  USART_Cmd(USART_2, DISABLE);
  USART_ITConfig(USART_2, USART_IT_RXNE | USART_IT_TXE, DISABLE);
  USART_InitStructure.USART_BaudRate = usart_speed;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Configure USART2 */ 
  USART_Init(USART_2, &USART_InitStructure);

  /* Enable USART2 Receive and Transmit interrupts USART2*/	
  USART_ITConfig(USART_2, USART_IT_RXNE, ENABLE);

  /* Enable the USART2 */  
  USART_Cmd(USART_2, ENABLE);
 }
//---------------------------------
//procedury inicjacji portu USART3)
 void USART3_Inicjacja(uint32_t usart_speed)
 {
  /* Enable the USART OverSampling by 8 */
  USART_OverSampling8Cmd(USART_3, ENABLE); 

  USART_Cmd(USART_3, DISABLE);
  USART_ITConfig(USART3, USART_IT_RXNE | USART_IT_TXE, DISABLE);
  USART_InitStructure.USART_BaudRate = usart_speed;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Configure USART3 */ 
  USART_Init(USART_3, &USART_InitStructure);

  /* Enable USART2 Receive and Transmit interrupts USART2*/	
  USART_ITConfig(USART_3, USART_IT_RXNE, ENABLE);

  /* Enable the USART2 */  
  USART_Cmd(USART_3, ENABLE);
 }

//--------------------------------------------------
//procedura transmisji USART1 zawartoci bufor_tx[]
void UART_Start_Tx1(void)
{
//procedura wcza przerwanie jeeli flaga  tx_restart ustawiona
//Rozpoczyna si transmisja buforu bufor_tx[] 
//kiedy wskaniki tx_out ==tx_in przerwanie zostaje automatycznie wyczone


	if (tx_USART1_restart_flag ==1)                                // If transmit interrupt is disabled, enable it
	{
		tx_USART1_restart_flag = 0;
		USART_ITConfig(USART1, USART_IT_TXE, ENABLE);	          // enable TX interrupt
	}
}	
//--------------------------------------------------
//procedura transmisji USART2 zawartoci bufor_tx[]
void UART_Start_Tx2(void)
{
//procedura wcza przerwanie jeeli flaga  tx_restart ustawiona
//Rozpoczyna si transmisja buforu bufor_tx[] 
//kiedy wskaniki tx_out ==tx_in przerwanie zostaje automatycznie wyczone

	if (tx_USART2_restart_flag ==1)     // If transmit interrupt is disabled, enable it
	{
		tx_USART2_restart_flag = 0;
		USART_ITConfig(USART2, USART_IT_TXE, ENABLE);	  // enable TX interrupt
	}
} 
//--------------------------------------------------
//procedura transmisji USART3 zawartoci bufor_tx_USART3[]
void UART3_Start_Tx(void)
{
//procedura wcza przerwanie jeeli flaga  tx_restart ustawiona
//Rozpoczyna si transmisja buforu bufor_tx_USART3[] 
//kiedy wskaniki tx_out ==tx_in przerwanie zostaje automatycznie wyczone


	if (tx_USART3_restart_flag ==1)                               // If transmit interrupt is disabled, enable it
	{
		tx_USART3_restart_flag = 0;
		USART_ITConfig(USART3, USART_IT_TXE, ENABLE);	          // enable TX interrupt
	}
}	

//-------------------------------------------------
//procedura wyboru trybu transmisji w zalenoci od aktualnie aktywnego kanau transmisji
//dla zawartoci bufora bufor_tx[]
char Selektor_Start_Tx(void)
//aktywny kana transmisji okrela aktualne ustawienie globalnej zmiennej proc_ogol_stan_urzadzenia_info
//wy: TRUE -transmisja danych zostaa rozpoczta
{
uint16_t rozmiar_transmisji;

	//rozmiar transmisji obliczany z rnicy wskanikw do koca i pocztku danych w buf.
	rozmiar_transmisji =p_TX_USART_GP_IN - p_TX_USART_GP_OUT;

	cnl_spoj_wymiany_danych.p_bufor_bak =p_TX_USART_GP_OUT;
	cnl_spoj_wymiany_danych.p_koniec_danych_bak =p_TX_USART_GP_IN;
	cnl_spoj_wymiany_danych.rozmiar_transmisji_bak =rozmiar_transmisji;
	cnl_spoj_wymiany_danych.stan_urzadzenia_bak =proc_ogol_stan_urzadzenia_info;
	//identyfikator transmisji zosta wczeniej zapamitany

	if (tx_USART1_restart_flag !=1) return FALSE;//poprzednia transmisja nie zakoczona, nie mona rozpocz kolejnej
	//transmisjia zawartoci bufor_tx[] kanaem UART-u
	UART_Start_Tx1();
	return TRUE;
}
//-----------------------------------------------------------------------
//procedura ponowienia tej samej transmisji
char Ponowienie_Transmisji(void)
{

	if (tx_USART1_restart_flag !=1) return FALSE;//poprzednia transmisja nie zakoczona, nie mona rozpocz kolejnej

    p_TX_USART_GP_OUT =cnl_spoj_wymiany_danych.p_bufor_bak;
	p_TX_USART_GP_IN =cnl_spoj_wymiany_danych.p_koniec_danych_bak;
	proc_ogol_stan_urzadzenia_info =cnl_spoj_wymiany_danych.stan_urzadzenia_bak;
	//identyfikator powtarzanej transmisji znajduje si ju w danych do ponownej transmisji

	//transmisjia zawartoci bufor_tx[] kanaem UART-u
	UART_Start_Tx1();
	return TRUE;
}
//-----------------------------------
//odczyt flagi ukoczenia wysyania zawartoci buforu
char Test_tx_USART_restart_flag(void)
{
	return TX_USART_GP_RESTART_FLAG;
}
