/*----------------------------------------------------------------------------
 * Nazwa:    Tryb_AT_obslugiwane_rozkazy.c	  
 * Funkcja: Plik procedur zwizanych z obsugiwanymi rozkazami Trybu AT (serwisowego) 
 * 			zalenie od typu urzdzenia
 * autor 	ARIES Ryszard Szymaniak www.arskam.com
 * wersja 	1.0
 * data    31-12-2012
 * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
 * 		STM32F217VGT
 *----------------------------------------------------------------------------
 * Plik zawiera:
 * 
 *
 * Copyright (c) 2011 ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
#include "Tryb_AT_obslugiwane_rozkazy.h"
#include "Tryb_AT.h"
#include "Tryb_AT_etykiety.h"
#include "Definicje_sprzet.h"
#include "Definicje_program.h"

//----------------------------------------------
//obsuga zidentyfikowanego rozkazu AT
//----------------------------------------------
//obsuga zidentyfikowanego rozkazu AT
void Obsluga_Rozkazu_AT(char *p_buf_serwis_tmp, uint16_t numer_rozkazu)
{
			switch(numer_rozkazu)
			{
				case ETYKIETA_ATsC://AT$C=
				{
					Obsluga_rozkazu_ATsC(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATCp://ATC?
				{
					Obsluga_rozkazu_ATCp();
					return;
				}
				case ETYKIETA_ATCw://ATC>
				{
					Obsluga_rozkazu_ATCw();
					return;
				}
				case ETYKIETA_ATDw://ATD>
				{
					Obsluga_rozkazu_ATDw();
					return;
				}
				case ETYKIETA_ATDp://ATD?
				{
					Obsluga_rozkazu_ATDp(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATDeq://ATD=
				{
					Obsluga_rozkazu_ATDeq();
					return;
				}
			    case ETYKIETA_ATK://AT/K
				{
					Obsluga_rozkazu_ATK();
					return;
				}
				case ETYKIETA_ATN://AT/N
				{
					Obsluga_rozkazu_ATN();
					return;
				}
				case ETYKIETA_ATO://ATO
				{
					Obsluga_rozkazu_ATO();
					return;
				}
				case ETYKIETA_ATsP://AT$P=
				{
					//Obsluga_rozkazu_ATsP(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATPp://ATP?
				{
					//Obsluga_rozkazu_ATPp();
					break;
				}
				case ETYKIETA_ATsR://AT$R
				{
					//Obsluga_rozkazu_ATsR(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATRp://ATR?
				{
					//Obsluga_rozkazu_ATRp();
					break;
				}
				case ETYKIETA_ATRm://ATR-
				{
					//Obsluga_rozkazu_ATRm();
					break;
				}							   
				case ETYKIETA_ATV://AT/V
				{
					Obsluga_rozkazu_ATV();
					return;
				}
				case ETYKIETA_ATS200eq://ATS200=
				{
					//Obsluga_rozkazu_ATS200eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS200p://ATS200?
				{
					//Obsluga_rozkazu_ATS200p();
					break;
				}
				case ETYKIETA_ATS200w://ATS200>
				{
					//Obsluga_rozkazu_ATS200w();
					break;
				}								
				case ETYKIETA_ATS201eq://ATS201=
				{
					//Obsluga_rozkazu_ATS201eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS201p://ATS201?
				{
					//Obsluga_rozkazu_ATS201p();
					break;
				}
				case ETYKIETA_ATS201w://ATS201>
				{
				    //Obsluga_rozkazu_ATS201w();
					break;
				}
				case ETYKIETA_ATS202eq://ATS202=
				{
					//Obsluga_rozkazu_ATS202eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS202p://ATS202?
				{
					//Obsluga_rozkazu_ATS202p();
					break;
				}
				case ETYKIETA_ATS202w://ATS202>
				{
					//Obsluga_rozkazu_ATS202w();
					break;
				}	
				case ETYKIETA_ATS210eq://ATS210=
				{
					Obsluga_rozkazu_ATS210eq(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS210p://ATS210?
				{
					Obsluga_rozkazu_ATS210p();
					return;
				}
				case ETYKIETA_ATS210w://ATS210>
				{
					Obsluga_rozkazu_ATS210w();
					return;
				}	
				case ETYKIETA_ATS220eq://ATS220=
				{
					//Obsluga_rozkazu_ATS220eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS220p://ATS220?
				{
					//Obsluga_rozkazu_ATS220p();
					break;
				}
				case ETYKIETA_ATS220w://ATS220>
				{
					//Obsluga_rozkazu_ATS220w();
					break;
				}
				case ETYKIETA_ATS221eq://ATS221=
				{
					//Obsluga_rozkazu_ATS221eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS221p://ATS221?
				{
					//Obsluga_rozkazu_ATS221p();
					break;
				}
				case ETYKIETA_ATS221w://ATS221>
				{
					//Obsluga_rozkazu_ATS221w();
					break;
				}
				case ETYKIETA_ATS222eq://ATS222=
				{
					//Obsluga_rozkazu_ATS222eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS222p://ATS222?
				{
					//Obsluga_rozkazu_ATS222p();
					break;
				}
				case ETYKIETA_ATS222w://ATS222>
				{
					//Obsluga_rozkazu_ATS222w();
					break;
				}
				case ETYKIETA_ATS223eq://ATS223=
				{
					//Obsluga_rozkazu_ATS223eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS223p://ATS223?
				{
					//Obsluga_rozkazu_ATS223p();
					break;
				}
				case ETYKIETA_ATS223w://ATS223>
				{
					//Obsluga_rozkazu_ATS223w();
					break;
				}		
#if (ZEGAR_RTC	== ZAMONTOWANY_ZEGAR_RTC)																			  								
				case ETYKIETA_ATsS230eq://AT$S230=
				{
					//Obsluga_rozkazu_ATsS230eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS230w://ATS230>
				{
					//Obsluga_rozkazu_ATS230w();
					break;
				}
				case ETYKIETA_ATsS231eq://AT$S231=
				{
					//Obsluga_rozkazu_ATsS231eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS231w://ATS231>
				{
					//Obsluga_rozkazu_ATS231w();
					break;
				}
#endif								  												  												  												  
				case ETYKIETA_ATS300eq://AT$S300=
				{
					//Obsluga_rozkazu_ATS300eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS300p://AT$S300?
				case ETYKIETA_ATS300px:
				{
					//Obsluga_rozkazu_ATS300p(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS300w://AT$S300>
				{
					//Obsluga_rozkazu_ATS300w();
					break;
				}
				case ETYKIETA_ATS301eq://AT$S301=
				{
					//Obsluga_rozkazu_ATS301eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS301p://AT$S301?
				{
					//Obsluga_rozkazu_ATS301p(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS301w://AT$S301>
				{
					//Obsluga_rozkazu_ATS301w(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS302eq://AT$S302=
				{
					//Obsluga_rozkazu_ATS302eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS302p://AT$S302?
				{
					//Obsluga_rozkazu_ATS302p(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS302w://AT$S302>
				{
					//Obsluga_rozkazu_ATS302w(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS400eq://ATS400=
				{
					Obsluga_rozkazu_ATS400eq(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS400p://ATS400?
				{
					Obsluga_rozkazu_ATS400p(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS400w://ATS400>
				{
					Obsluga_rozkazu_ATS400w(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS401eq://ATS401=
				{
					Obsluga_rozkazu_ATS401eq(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS401p://ATS401?
				{
					Obsluga_rozkazu_ATS401p(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS401w://ATS401>
				{
					Obsluga_rozkazu_ATS401w(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS402eq://ATS402=
				{
					Obsluga_rozkazu_ATS402eq(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS402p://ATS402?
				{
					Obsluga_rozkazu_ATS402p(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS402w://ATS402>
				{
					Obsluga_rozkazu_ATS402w(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS403eq://ATS403=
				{
					//Obsluga_rozkazu_ATS403eq(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS403p://ATS403?
				{
					//Obsluga_rozkazu_ATS403p(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS403w://ATS403>
				{
					//Obsluga_rozkazu_ATS403w(p_buf_serwis_tmp);
					break;
				}
				case ETYKIETA_ATS404eq://ATS404=
				{
					Obsluga_rozkazu_ATS404eq(p_buf_serwis_tmp);
					return;
				}
				case ETYKIETA_ATS404p://ATS404?
				{
					Obsluga_rozkazu_ATS404p();
					return;
				}
				case ETYKIETA_ATS404w://ATS404>
				{
					Obsluga_rozkazu_ATS404w();
					return;
				}

				default:
				{
					break;
				}
			}
			Tryb_AT_komunikat_ERROR(BLAD_ROZKAZ_NIE_ROZPOZNANY);

}
