/**
  ******************************************************************************
  * plik    GPIO_procedury.h
  * funkcja	Plik nagwkowy procedur obsugi sprztowych linii IO mikrokontrolera
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    8-08-2012
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __GPIO_PROCEDURY_H
#define __GPIO_PROCEDURY_H

#include "stm32f2xx_conf.h"
#include "Definicje_sprzet.h"

void GPIO_Inicjacja(void);
void GPIO_Linie_IO_Inicjacja(Linie_IO_TypeDef Linia, GPIOMode_TypeDef tryb_pracy, GPIOOType_TypeDef typ_linii_wy);
void GPIO_Linie_IO_High(Linie_IO_TypeDef Linia);
void GPIO_Linie_IO_Low(Linie_IO_TypeDef Linia);
uint32_t GPIO_Linie_IO_Odczyt(Linie_IO_TypeDef Linia);

#endif
