/**
  ******************************************************************************
  * plik    USART_procedury.h	
  * funkcja	Plik nagwkowy procedur zwizanych z portami szeregowymi USART 
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    8-08-2012
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __USART_PROCEDURY_H
#define __USART_PROCEDURY_H

//#include "Definicje.h"
#include "stm32f2xx_conf.h"
#include "Definicje_program.h"

//przypisanie wskanikw i zmiennych USART1 do definicji Gwnego Portu USART urzdzenia
extern char bufor_rx_USART1[ROZMIAR_BUF_RX_TX];//bufor transmisji UARTA1
#define POCZ_BUFOR_RX_USART_GP		&bufor_rx_USART1[0]
#define p_BUFOR_RX_USART_GP			p_bufor_rx_USART1//wskanik do pocztku buforu odbiorczego Gwnego Portu USART
#define BUFOR_RX_USART_GP_ROZMIAR	bufor_rx_USART1_rozmiar//bajt okrelajcy cakowity rozmiar buforu odbiorczego Gwnego Portu USART
#define p_RX_USART_GP_IN			p_rx_USART1_in//wskanik biecej pozycji w buf.odbiorczym dla danych zapisywanych w buf. Gwnego Portu USART
#define p_RX_USART_GP_OUT			p_rx_USART1_out//wskanik biecej pozycji w buf.odbiorczym dla danych odczytywanych z buf. Gwnego Portu USART


extern char bufor_tx_USART1[ROZMIAR_BUF_RX_TX];//bufor transmisji UARTA1
#define POCZ_BUFOR_TX_USART_GP		&bufor_tx_USART1[0]
#define p_BUFOR_TX_USART_GP 		p_bufor_tx_USART1//wskanik do pocztku buforu transmisji Gwnego Portu USART 
#define BUFOR_TX_USART_GP_ROZMIAR 	bufor_tx_USART1_rozmiar//bajt okrelajcy cakowity rozmiar buforu transmisji Gwnego Portu USART 
#define p_TX_USART_GP_IN			p_tx_USART1_in//wskanik biecej pozycji w buf.nadawczym dla danych zapisywanych w buf. Gwnego Portu USART 
#define p_TX_USART_GP_OUT			p_tx_USART1_out//wskanik biecej pozycji w buf.nadawczym dla danych odczytywanych z buf.	Gwnego Portu USART 
#define TX_USART_GP_RESTART_FLAG	tx_USART1_restart_flag//poprzednia transmisja Gwnego Portu USART zakoczona, nowa musi by zainicjowana

#define PRZERWA_TRANSMISJI_USART_GP_FLAG	przerwa_transmisji_USART1_flag
#define CZAS_PRZERWY_TRANSMISJI_UART_GP		czas_przerwy_transmisji_UART1

#define ILOSC_SZYBKOSCI_TRANSMISJI_UART	8

void USART_Inicjacja(void);
void USART1_GPIO_Configuration(void);
void USART2_GPIO_Configuration(void);
void USART3_GPIO_Configuration(void);
void USART1_Inicjacja(uint32_t usart_speed);
void USART2_Inicjacja(uint32_t usart_speed);
void USART3_Inicjacja(uint32_t usart_speed);
void UART_Start_Tx1(void);
void UART_Start_Tx2(void);
void UART3_Start_Tx(void);
char Selektor_Start_Tx(void);
char Ponowienie_Transmisji(void);
char Test_tx_USART_restart_flag(void);

#endif


