/*----------------------------------------------------------------------------
 * Nazwa:   DMA_procedury.h	  
 * Funkcja: Plik nagwkowy procedur zwizanych z kanaami DMA
 *          Arm3S-K
 * 	
 * Version: V1.00
 *----------------------------------------------------------------------------
 * Plik zawiera:
 * deklaracje procedur zwizanych z obsug kanaw DMA
 *
 * Copyright (c) 2010 ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __DMA_PROCEDURY_H
#define __DMA_PROCEDURY_H

#include "stm32f2xx_conf.h"

#define ROZMIAR_POJEDYNCZEGO_PRZESLANIA_DMA_DLA_JPG		0xFF00
#define ERR_JPG_DANE_BRAK_BLEDU			0
#define ERR_JPG_DANE_DCMI_BLAD			1
#define ERR_JPG_DANE_BUFOR_ZA_MALY		2
#define ERR_JPG_DANE_BLAD_ODCZYTU_DMA	3
#define ERR_JPG_DANE_BRAK_DANYCH		255
 
void Inicjacja_DMA_MT9D111_BMP_RAM(uint8_t *bufor_RAM_danych_obrazka, int image_width, int image_height, char bajty_na_piksel);
void Start_DMA_MT9D111_BMP_do_Int_RAM(int image_width, int image_height, char bajty_na_piksel);
void Inicjacja_DMA_MT9D111_JPG_RAM(uint8_t *bufor_RAM_pliku_obrazka_format, int rozmiar_pojedynczego_przeslania_DMA);
uint32_t Start_DMA_Dane_JPG_Ramki_MT9D111_do_Int_RAM(uint32_t *p_rozmiar_przeslania_max, 
													 uint32_t rozmiar_pojedynczego_przeslania_DMA);

#endif

