/**
  ******************************************************************************
  * plik    MT9D111_JPG.h
  * funkcja	plik nagwkowy procedur JPG moduu kamery MT9D111
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    29-10-2012
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __MT9D111_JPG_H
#define __MT9D111_JPG_H

#define FORMAT_YCBCR422		0
#define FORMAT_YCBCR420		1
#define FORMAT_MONOCHROME  	2

int JfifApp0Marker(char *pbuf);
int FrameHeaderMarker(char *pbuf, int width, int height, int format);
int ScanHeaderMarker(char *pbuf, int format);
int DefineQuantizationTableMarker(char *pbuf, int qscale, int format);
int DefineHuffmanTableMarkerDC(char *pbuf, unsigned int *htable, int class_id);
int DefineHuffmanTableMarkerAC(char *pbuf, unsigned int *htable, int class_id);
int DefineRestartIntervalMarker(char *pbuf, int ri);
int CreateJpegHeader(char *header, int width, int height, int format, int restart_int, int qscale);
char MT9D111_JPG_Inicjacja_Rejestrow_1(unsigned char format_koloru_obrazka, unsigned char wspolczynnik_kompresji, char format_obrazu );
uint32_t mt9d111_zapis_do_buf_ramki_JPG_1(uint32_t* p_rozmiar_przeslania_max, uint32_t rozmiar_pojedynczego_przeslania_DMA);
uint32_t mt9d111_zapis_do_buf_ramki_JPG_2(uint32_t* p_rozmiar_przeslania_max, uint32_t rozmiar_pojedynczego_przeslania_DMA);


#endif
