/*----------------------------------------------------------------------------
 * Nazwa:   Definicje_program.h	  
 * Funkcja: Plik nagwkowy globalnych definicji	
 * @author  ARIES
 *
 * opis:   	system ARS3 dla pytki ARS3-RZ (radio/zegar RTC)
 * ukad:	STM32F101C8
 * Version: V1.00
 * data:    31-12-2012
 *----------------------------------------------------------------------------
 * Plik zawiera:
 *
 *
 * Copyright (c) 2010 ARIES. All rights reserved.
 *----------------------------------------------------------------------------*/
/* Define to prevent recursive inclusion ------------------------------------ */

#ifndef __DEFINICJE_PROGRAM_H
#define __DEFINICJE_PROGRAM_H

#include "EEPROM_procedury.h"

//deklaracje GPIO
#define ZAPAL_LED_RX		0
#define ZAPAL_LED_TX		1
#define ZAPAL_LED_RX_TRWALE	2
#define ZAPAL_LED_TX_TRWALE	3
#define ZGAS_LED_RX			4
#define ZGAS_LED_RX_TX		0xFF

//deklaracje staych szybkoci USART-a
#define U_1200_BAUD		1200
#define U_2400_BAUD		2400
#define U_4800_BAUD		4800
#define U_9600_BAUD		9600
#define U_19200_BAUD	19200
#define U_38400_BAUD	38400
#define U_57600_BAUD	57600
#define U_115200_BAUD	115200
//deklaracje przerwy w transmisji =1 ramce, pomiar w 0.1ms
#define U_1200_PRZERWA_01MS		84
#define U_2400_PRZERWA_01MS		42
#define U_4800_PRZERWA_01MS		21
#define U_9600_PRZERWA_01MS	    11
#define U_19200_PRZERWA_01MS	6
#define U_38400_PRZERWA_01MS	3
#define U_57600_PRZERWA_01MS	2
#define U_115200_PRZERWA_01MS	1

//czas po jakim nastpi automatyczne zamknicie Trybu AT
#define CZAS_AUTOMAT_ZAMKNIECIA_TRYBU_AT_MS	10000//10s

//USART
#define ROZMIAR_BUF_RX_TX	0x400

//definicje aktualnego trybu pracy urzdzenia
#define STAN_URZADZENIA_RX_TX				0	//urzdzenie w normalnym trybie odbioru/nadawania
#define STAN_URZADZENIA_TRYB_AT_UART		1   //Tryb AT (serwisowy) wywoany z UART-a
#define STAN_URZADZENIA_TRYB_TRANS_UART		2	//tryb transmisji kanaem interfejsu szeregowego UART
#define STAN_URZADZENIA_TRYB_AT_RADIO		3	//Tryb AT (serwisowy) wywoany z Radia
#define STAN_URZADZENIA_TRYB_TRANS_RADIO	4	//tryb transmisji kanaem Radiowym
#define STAN_URZADZENIA_TRYB_AT_UART_RE_RADIO		5   //Tryb AT (serwisowy) wywoany z UART-a	i retransmitowany kanaem radio
#define STAN_URZADZENIA_TRYB_AT_UART_RE_RADIO_ZAMYKANIE		6   //Tryb AT (serwisowy) retransmitowany kanaem radio
																//oczekiwanie na zamknicie
#define STAN_URZADZENIA_TRYB_AT_UART_RE_RADIO_OTWIERANIE	7   //Tryb AT (serwisowy) retransmitowany kanaem radio
																//oczekiwanie na potwierdzenie otwarcia

//definicje kodw bdu
#define BRAK_BLEDU						0
#define BLAD_ROZMIARU_ROZKAZU			1	//przesany rozkaz ma rozmiar wikszy od dopuszczalnego
#define BLAD_ROZKAZ_NIE_ROZPOZNANY		2	//rozkaz nie zosta rozpoznany
#define BLAD_ZAPISU_DO_PAMIECI_KONFIG	3	//bd zapisu do pamici konfiguracyjnej urzdzenia
#define BLAD_ODCZYTU_Z_PAMIECI_KONFIG	4	//bd odczytu z pamici konfiguracyjnej urzdzenia
#define BLAD_BRAK_MIEJSCA_NA_DANE		5	//brak miejsca na przesane dane
#define BLAD_BRAK_ZNACZNIKOW_PLIKU		6	//brak znacznikw pocztku lub koca przypisa w profilu ustawie rejestrw radiowych
#define BLAD_PRZESLANEGO_PARAMETRU		7	//bd przesanego parametru (bdny string lub zakres)
#define BLAD_PARAM_Z_PAMIECI_KONFIG		8	//parametr odczytany z pamici konfiguracyjnej jest bdny
#define BLAD_PLIKU_USTAWIEN_REG_RADIO	9	//bd struktury profilu ustawie rejestrw radiowych
#define BLAD_PLIK_NIE_ISTNIEJE			10	//plik do odczytu w podanej lokalizacji nie istnieje
#define BLAD_WYNIKOWY_JPG_ZBYT_DUZY		11  //utworzony po kompresji plik JPG jest zbyt duy
#define BLAD_ODCZYTU_Z_SD				12	//bd odczytu z karty SD
#define BLAD_PROGRAMOWANIA_UKLADU		13  //bd programowania podsystemu/ukadu
#define BLAD_NIE_MOZNA_USTAWIC_PREFIKSU	14	//ustawienie prefiksu jest niemoliwe

//identyfikatory komend Trybu Formatowanego
#define PREFIKS_STRINGU_POLECEN					'$'
#define POZ_PREFIKSU_STRINGU_POLECEN			0
#define POZ_KOMENDY_STRINGU_POLECEN				2
#define TRYB_FORMAT_KOMENDA_A					'A'
#define TRYB_FORMAT_KOMENDA_P					'P'
#define TRYB_FORMAT_KOMENDA_D					'D'
#define TRYB_FORMAT_KOMENDA_C					'C'
#define TRYB_FORMAT_KOMENDA_U					'U'
#define TRYB_FORMAT_KOMENDA_I					'I'
#define TRYB_FORMAT_KOMENDA_F					'F'
#define TRYB_FORMAT_PREFIKS_f					'f'
#define TRYB_FORMAT_KOMENDA_M					'M'

#define TRYB_FORMAT_IDENTYFIKATOR_TRANS_MIN		'1'
#define TRYB_FORMAT_IDENTYFIKATOR_TRANS_MAX		'7'

//BUFORY
//------
//centralny bufor danych obrazka
#define ROZMIAR_BUFORU_DANYCH			85000
#define POCZATEK_BUFORU_PLIKU_JPG		0
#define POCZATEK_BUFORU_16_LINII_OBRAZU	ROZMIAR_BUFORU_DANYCH -((640*2)*8)
#define ROZMIAR_DANYCH_OBRAZU_QQVGA		((160*2)*120)		 //38400
#define POCZATEK_BUFORU_OBRAZU_QQVGA    ROZMIAR_BUFORU_DANYCH - (ROZMIAR_DANYCH_OBRAZU_QQVGA+10)
#define ROZMIAR_BUFORU_PLIKU_OBRAZU		70000//ROZMIAR_BUFORU_DANYCH -((640*2)*8)//68000-1000
//char bufor_RAM_danych[ROZMIAR_BUFORU_DANYCH];	main.c

//LINIE I/O i RDA ZDARZE
//--------------------------
#define ILOSC_STANOW_LINII_IO	3
#define STAN_LINII_L				0
#define STAN_LINII_H				1
#define STAN_LINII_OFF				2
#define STAN_LINII_ZMIANA			2
#define PAUZA_MS_MIN				10
#define PAUZA_MS_MAX				0xFFFF
#define KOMUNIKAT_ILE_ZNAKOW_MIN	1
//2:numer nrda 1:$ ROZMIAR_ALIASU_MAX 1:=/# 5:cyfry parametru
#define KOMUNIKAT_ILE_ZNAKOW_MAX	2+1+ROZMIAR_ALIASU_MAX+1+5
#define PARAMETR_WARTOSC_MIN		0
#define PARAMETR_WARTOSC_MAX		0xFFFF

#define ROZMIAR_INFO_SCENARIUSZA_MAX	200+195

//definicja zwizane z trybem kodowania JPG
#define KODOWANIE_JPG_Z_EXT_SRAM		0
#define KODOWANIE_JPG_Z_PLIKU_NA_SD	    1

#define TRYB_FORMAT_IDENTYFIKATOR_OBRAZKA_MINI	'<'
#define TRYB_FORMAT_IDENTYFIKATOR_OBRAZKA_MAXI	'>'
#define TRYB_FORMAT_NAZWA_POLOZENIE_OBRAZKA_OZO 	"/ozo_.jpg"	//identyfikator ostatnio zarejestrowanego obrazka (ozo)
#define ILE_PIERWSZYCH_ZNAKOW_IDENTYFIKACJI_OZO	5

//definicje zwizane ze ustawieniami pracy kamery
#define ILOSC_OPCJI_PRACY_KAMERY		4

//definicje zwizane ze skadni rozkazw serwisowych i polece
#define ZABRONIONE_ZNAKI_STRINGU        					".,;: $@%#^&=[]()"
#define ZABRONIONE_ZNAKI_STRINGU_BEZ_PRZEC_KRATKA_EQU_DOLAR	".;: @%^&[]()"
#define ZABRONIONE_ZNAKI_STRINGU_BEZ_SPAC_EQU				".,;:$@%#^&[]()"

#define ZNACZNIK_OTWIERAJ_NR_POZYCJI    '('
#define ZNACZNIK_ZAMYKAJ_NR_POZYCJI     ')'
#define FORMAT_PARAMETRU_LICZBA			'='
#define FORMAT_PARAMETRU_STRING			'$'
#define FORMAT_PARAMETRU_NUMER_STRING	'%'
#define FORMAT_PARAMETRU_NUMER_ZRODLA	'#'


//definicje globalne
#define FALSE	0
#define TRUE	1
#define BLAD		 -1
#define SUKCES		 1

#define NULL 0
#define POZIOM_L	 0
#define POZIOM_H	 1

#define FLAGA_USTAWIONA		'1'
#define FLAGA_SKASOWANA		'0'

#define ODCZYT_ZE_ZRODLA_NIEMOZLIWY	0x10000

#define bool	char

#endif

