/**
  ******************************************************************************
  * plik    Definicje_sprzet.h
  * funkcja	Plik nagwkowy globalnych definicji zwizanych z czci sprztow
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.02
  * data    2-01-2013
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
#ifndef __DEFINICJE_SPRZET_H
#define __DEFINICJE_SPRZET_H

//zegar RTC						
//----------------------------------------------------------------------
#define BRAK_ZEGARA_RTC			0	//zegar RTC wraz z bateri podtrzymujc nie s zamontowane
#define ZAMONTOWANY_ZEGAR_RTC	1	//zegar RTC i bateria podtrzymujca s zamontowane
	#define ZEGAR_RTC			BRAK_ZEGARA_RTC
//kamera
//----------------------------------------------------------------------
#define BRAK_ZAMONTOWANEJ_KAMERY	0
#define ZAMONTOWANA_KAMERA_MT9D111	1
	#define ZAMONTOWANA_KAMERA		ZAMONTOWANA_KAMERA_MT9D111

//definicje linii IO
#define LINIE_IOn						5
typedef enum
{
	LINIA_LED_ZIELONY_WY	=0,
	LINIA_LED_CZERWONY_WY	=1,	  
	LINIA_MCO2_ZEGAR_WY		=2,
	LINIA_EEP_SDA			=3,
    LINIA_EEP_SCL			=4
}Linie_IO_TypeDef;
	//LED_ZIELONY_WY linia wyjciowa led zielonego
#define LINIA_LED_ZIELONY_WY_PORT			GPIOB
//#define LINIA_LED_ZIELONY_WY_PORT_NUM		GPIO_PortSourceGPIOE	   
#define LINIA_LED_ZIELONY_WY_CLK			RCC_AHB1Periph_GPIOB             
#define LINIA_LED_ZIELONY_WY_PIN			GPIO_Pin_0
#define LINIA_LED_ZIELONY_WY_PIN_SOURC		GPIO_PinSource0
	//LED_CZERWONY_WY linia wyjciowa led czerwonego
#define LINIA_LED_CZERWONY_WY_PORT			GPIOB
//#define LINIA_LED_CZERWONY_WY_PORT_NUM		GPIO_PortSourceGPIOE	   
#define LINIA_LED_CZERWONY_WY_CLK			RCC_AHB1Periph_GPIOB             
#define LINIA_LED_CZERWONY_WY_PIN			GPIO_Pin_1
#define LINIA_LED_CZERWONY_WY_PIN_SOURC		GPIO_PinSource1
	//MCO2_ZEGAR_WY wyjcie sygnau zegarowego
#define LINIA_MCO2_ZEGAR_WY_PORT			GPIOA
#define LINIA_MCO2_ZEGAR_WY_CLK				RCC_AHB1Periph_GPIOA          
#define LINIA_MCO2_ZEGAR_WY_PIN				GPIO_Pin_8
#define LINIA_MCO2_ZEGAR_WY_PIN_SOURC		GPIO_PinSource8
	//EEPROM linia SDA
#define LINIA_EEP_SDA_PORT					GPIOB
#define LINIA_EEP_SDA_CLK 					RCC_AHB1Periph_GPIOB
#define LINIA_EEP_SDA_PIN					GPIO_Pin_11
#define LINIA_EEP_SDA_PIN_SOURC				GPIO_PinSource11
	//EEPROM linia SCL
#define LINIA_EEP_SCL_PORT					GPIOB
#define LINIA_EEP_SCL_CLK 					RCC_AHB1Periph_GPIOB
#define LINIA_EEP_SCL_PIN					GPIO_Pin_10
#define LINIA_EEP_SCL_PIN_SOURC				GPIO_PinSource10

//definicja USART1, USART2, USART3
#define USARTx_CLK_INIT   RCC_APB1PeriphClockCmd

#define USART_1                          USART1
#define USART_1_CLK                      RCC_APB2Periph_USART1
#define USART_1_CLK_INIT                 RCC_APB2PeriphClockCmd
#define USART_1_IRQn                     USART1_IRQn
#define USART_1_IRQHandler               USART1_IRQHandler

#define USART_1_TX_PIN                   GPIO_Pin_9               
#define USART_1_TX_GPIO_PORT             GPIOA                      
#define USART_1_TX_GPIO_CLK              RCC_AHB1Periph_GPIOA
#define USART_1_TX_SOURCE                GPIO_PinSource9
#define USART_1_TX_AF                    GPIO_AF_USART1

#define USART_1_RX_PIN                   GPIO_Pin_10              
#define USART_1_RX_GPIO_PORT             GPIOA                    
#define USART_1_RX_GPIO_CLK              RCC_AHB1Periph_GPIOA
#define USART_1_RX_SOURCE                GPIO_PinSource10
#define USART_1_RX_AF                    GPIO_AF_USART1
//--------------------------------------------------------

#define USART_2                           USART2
#define USART_2_CLK                       RCC_APB1Periph_USART2
#define USART_2_CLK_INIT                  RCC_APB1PeriphClockCmd
#define USART_2_IRQn                      USART2_IRQn
#define USART_2_IRQHandler                USART2_IRQHandler

#define USART_2_TX_PIN                    GPIO_Pin_2               
#define USART_2_TX_GPIO_PORT              GPIOA                      
#define USART_2_TX_GPIO_CLK               RCC_AHB1Periph_GPIOA
#define USART_2_TX_SOURCE                 GPIO_PinSource2
#define USART_2_TX_AF                     GPIO_AF_USART2

#define USART_2_RX_PIN                    GPIO_Pin_3               
#define USART_2_RX_GPIO_PORT              GPIOA                   
#define USART_2_RX_GPIO_CLK               RCC_AHB1Periph_GPIOA
#define USART_2_RX_SOURCE                 GPIO_PinSource2
#define USART_2_RX_AF                     GPIO_AF_USART2
//---------------------------------------------------------

#define USART_3                           USART3
#define USART_3_CLK                       RCC_APB1Periph_USART3
#define USART_3_CLK_INIT                  RCC_APB1PeriphClockCmd
#define USART_3_IRQn                      USART3_IRQn
#define USART_3_IRQHandler                USART3_IRQHandler

#define USART_3_TX_PIN                    GPIO_Pin_10                
#define USART_3_TX_GPIO_PORT              GPIOC                       
#define USART_3_TX_GPIO_CLK               RCC_AHB1Periph_GPIOC
#define USART_3_TX_SOURCE                 GPIO_PinSource10
#define USART_3_TX_AF                     GPIO_AF_USART3

#define USART_3_RX_PIN                    GPIO_Pin_11                
#define USART_3_RX_GPIO_PORT              GPIOC                    
#define USART_3_RX_GPIO_CLK               RCC_AHB1Periph_GPIOC
#define USART_3_RX_SOURCE                 GPIO_PinSource11
#define USART_3_RX_AF                     GPIO_AF_USART3


//DEFINICJE STAYCH I ZMIENNYCH PROGRAMU

#define ROZMIAR_SCIEZKI_DOSTEPU_MAX		65
#define LIST_MAXLENFILENAME 12
//definicje globalne
#define FALSE	0
#define TRUE	1
#define BLAD		 -1
#define SUKCES		 1

#define NULL 0
#define POZIOM_L	 0
#define POZIOM_H	 1



#endif

