/**
  ******************************************************************************
  * plik    Tryb_AT.h
  * funkcja	Plik nagwkowy procedur zwizanych z Trybem AT (serwisowym)
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * Version: V1.01
  * data:    1-1-2013
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
#ifndef __TRYB_AT_H
#define __TRYB_AT_H

#include "stm32f2xx_conf.h"

char Kontrola_komendy_tryb_AT_on(char *p_bufor, uint16_t bufor_rozmiar, char *p_dane_pocz, char *p_dane_kon);
uint16_t Oblicz_Ilosc_Danych_w_Buf_Kolowym(char *p_bufor, uint16_t bufor_rozmiar, char *p_dane_pocz, char *p_dane_kon);
char *Odczyt_z_Buf_Kolowego_do_Buf_Liniowego(char *p_bufor, uint16_t bufor_rozmiar, char *p_dane_pocz, 
                                             uint16_t ile_do_odczytu, char *p_buf_liniowy);
void Obsluga_Trybu_AT(char *p_bufor, uint16_t bufor_rozmiar, char *p_dane_pocz, char *p_dane_kon);
const char *Odczyt_Stringu_Rozkazu(uint16_t numer_rozkazu);
void Obsluga_Rozkazu_AT(char *p_buf_serwis_tmp, uint16_t numer_rozkazu);

void Tryb_AT_potwierdzenie_OK(void);
void Tryb_AT_komunikat_ERROR(char kod_bledu);
void Obsluga_rozkazu_ATO(void);
void Obsluga_rozkazu_ATsC(char *p_buf);
void Obsluga_rozkazu_ATCp(void);
void Obsluga_rozkazu_ATCw(void);
void Obsluga_rozkazu_ATDeq(void);
void Obsluga_rozkazu_ATDw(void);
void Obsluga_rozkazu_ATDp(char *p_buf_rozkazu);
void Obsluga_rozkazu_ATDp_x(char *p_buf_rozkazu);
char Obsluga_rozkazu_ATDp_x_ekstrakcja_nazwy(char *p_etykieta_AT_tab, char *p_nazwa_rozkazu_tab);

void Obsluga_rozkazu_ATK(void);
void Obsluga_rozkazu_ATN(void);
void Obsluga_rozkazu_ATV(void);
void Obsluga_rozkazu_ATS210eq(char *p_buf);
void Obsluga_rozkazu_ATS210p(void);
void Obsluga_rozkazu_ATS210w(void);
void Obsluga_rozkazu_ATS400eq(char *p_buf);
void Obsluga_rozkazu_ATS400p(char *p_buf);
void Obsluga_rozkazu_ATS400w(char *p_buf);
void Obsluga_rozkazu_ATS401eq(char *p_buf);
void Obsluga_rozkazu_ATS401p(char *p_buf);
void Obsluga_rozkazu_ATS401w(char *p_buf);
void Obsluga_rozkazu_ATS402eq(char *p_buf);
void Obsluga_rozkazu_ATS402p(char *p_buf);
void Obsluga_rozkazu_ATS402w(char *p_buf);
void Obsluga_rozkazu_ATS404eq(char *p_buf);
void Obsluga_rozkazu_ATS404p(void);
void Obsluga_rozkazu_ATS404w(void);

#endif
