/**
  ******************************************************************************
  * plik    Tryb_Formatowany.h		 
  * funkcja	Plik nagwkowy procedur zwizanych z transmisj w Trybie Formatowanym 
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    15-08-2012
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __TRYB_FORMATOWANY_H
#define __TRYB_FORMATOWANY_H

#include "stm32f2xx_conf.h"                        // STM32F2x Library Definitions

#define ROZMIAR_BUFORU_LINIOWEGO	 					512
#define ROZMIAR_POJEDYNCZEGO_PRZESLANIA_DANYCH_PLIKU	512

//identyfikatory komend Trybu Formatowanego
#define PREFIKS_STRINGU_POLECEN					'$'
#define POZ_PREFIKSU_STRINGU_POLECEN			0
#define POZ_KOMENDY_STRINGU_POLECEN				2
#define TRYB_FORMAT_KOMENDA_A					'A'
#define TRYB_FORMAT_KOMENDA_P					'P'
#define TRYB_FORMAT_KOMENDA_D					'D'
#define TRYB_FORMAT_KOMENDA_C					'C'
#define TRYB_FORMAT_KOMENDA_U					'U'
#define TRYB_FORMAT_KOMENDA_I					'I'
#define TRYB_FORMAT_KOMENDA_F					'F'
#define TRYB_FORMAT_PREFIKS_f					'f'
#define TRYB_FORMAT_KOMENDA_M					'M'

#define TRYB_FORMAT_IDENTYFIKATOR_TRANS_MIN		'1'
#define TRYB_FORMAT_IDENTYFIKATOR_TRANS_MAX		'7'


void Obsluga_Trybu_Formatowanego(char *p_bufor, uint16_t bufor_rozmiar, char *p_dane_pocz, char *p_dane_kon);
char * Dekodowanie_Obsluga_polecenia_Tr_Format(char *p_buf_tryb_format_tmp);
void Tr_Format_A(void);
void Tr_Format_ERROR(char kod_bledu, char *p_koment);
void Tr_Format_Potwierdzenie_Break(uint8_t otwarty_kanal_transmisji, uint16_t czas_pauzy_ms);
char * Tr_Format_Obsluga_polecenia_D(char *p_buf_tryb_format_tmp, uint16_t rozmiar_parametru);
char * Tr_Format_Obsluga_polecenia_F(char *p_buf_tryb_format_tmp, uint16_t rozmiar_parametru);
char * Tr_Format_Obsluga_polecenia_P(char *p_buf_tryb_format_tmp, uint16_t rozmiar_parametru);

#endif
